﻿using System;
using System.Linq;
using System.Web;
using System.Xml.Linq;
using System.Collections;

public partial class _Default : System.Web.UI.Page
{
    static ArrayList YearArray;

    /// <summary>
    /// Page Load Event
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            FillArrayList();
            lstYears.DataSource = YearArray;
            lstYears.DataBind();
        }

    }

    /// <summary>
    /// Reload List
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnReload_Click(object sender, EventArgs e)
    {
        FillArrayList();
        lstYears.DataSource = YearArray;
        lstYears.DataBind();
    }

    /// <summary>
    /// Fill the ArrayList
    /// </summary>
    private void FillArrayList()
    {
        YearArray = new ArrayList();
        YearArray.Add("Year - 2010");
        YearArray.Add("Year - 2011");
        YearArray.Add("Year - 2012");
        YearArray.Add("Year - 2013");
        YearArray.Add("Year - 2014");
        YearArray.Add("Year - 2015");
        YearArray.Add("Year - 2016");
        YearArray.Add("Year - 2017");
        YearArray.Add("Year - 2018");
        YearArray.Add("Year - 2019");
        YearArray.Add("Year - 2020");
    }

    /// <summary>
    /// Add Item
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnAdd_Click(object sender, EventArgs e)
    {
        if (txtCriteria.Text.Trim() != "")
        {
            YearArray.Add(txtCriteria.Text.Trim());
            lstYears.DataSource = YearArray;
            lstYears.DataBind();
            lblMessage.Text = "ArrayList Item Added";
        }
        else
        {
            lblMessage.Text = "Please Enter an Item to Add";
        }
    }

    /// <summary>
    /// Delete Item
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDelete_Click(object sender, EventArgs e)
    {
        if (txtCriteria.Text.Trim() != "")
        {
            if (YearArray.Contains(txtCriteria.Text.Trim()))
            {
                YearArray.Remove(txtCriteria.Text.Trim());
                lstYears.DataSource = YearArray;
                lstYears.DataBind();

                //YearArray.RemoveAt(1);
                lblMessage.Text = "ArrayList Item Deleted";
            }
            else
            {
                lblMessage.Text = "Item Not Found.";
            }
        }
        else
        {
            lblMessage.Text = "Please Enter an Item to Delete";
        }

    }

    /// <summary>
    /// Clear Items
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnClear_Click(object sender, EventArgs e)
    {
        YearArray.Clear();
        lstYears.DataSource = YearArray;
        lstYears.DataBind();
        lblMessage.Text = "ArrayList Items Cleared";
    }

    /// <summary>
    /// Count Array Items
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnCount_Click(object sender, EventArgs e)
    {
        int intCount = YearArray.Count;
        lblMessage.Text = "ArrayList Items Count:" + intCount;
    }

    /// <summary>
    /// Sort Items
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnSort_Click(object sender, EventArgs e)
    {
        YearArray.Sort();
        lstYears.DataSource = YearArray;
        lstYears.DataBind();
        lblMessage.Text = "ArrayList Items Sorted";
    }

    /// <summary>
    /// Reverse Sort
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnReverse_Click(object sender, EventArgs e)
    {
        YearArray.Reverse();
        lstYears.DataSource = YearArray;
        lstYears.DataBind();
        lblMessage.Text = "ArrayList Items Reversed";
    }

    /// <summary>
    /// Intert Item
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnInsert_Click(object sender, EventArgs e)
    {
        if (txtCriteria.Text.Trim() != "")
        {
            YearArray.Insert(0, txtCriteria.Text.Trim());
            lstYears.DataSource = YearArray;
            lstYears.DataBind();
            lblMessage.Text = "ArrayList Item Inserted";
        }
        else
        {
            lblMessage.Text = "Please Enter an Item to Insert";
        }
    }

    /// <summary>
    /// binary Search
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnBinarySearch_Click(object sender, EventArgs e)
    {
        if (txtCriteria.Text.Trim() != "")
        {
            int Index = YearArray.BinarySearch(txtCriteria.Text.Trim());
            if (Index > 0)
                lblMessage.Text = "Item Found in Binary Search";
            else
                lblMessage.Text = "Item Not Found in Binary Search";
        }
        else
        {
            lblMessage.Text = "Please Enter an Item to Binay Search";
        }
    }

    /// <summary>
    /// Convert To Array
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnToArray_Click(object sender, EventArgs e)
    {
        object[] strYear = YearArray.ToArray();
        if (strYear != null && strYear.Count() > 0)
            lblMessage.Text = "ArrayList Converted in Array.";

    }

    /// <summary>
    /// Check for item 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnContains_Click(object sender, EventArgs e)
    {
        if (txtCriteria.Text.Trim() != "")
        {
            if (YearArray.Contains(txtCriteria.Text.Trim()))
            {
                lblMessage.Text = "ArrayList Item Found";
            }
            else
            {
                lblMessage.Text = "ArrayList Item Not Found.";
            }
        }
        else
        {
            lblMessage.Text = "Please Enter an Item to Delete";
        }
    }

    /// <summary>
    /// Find Index of an Item
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnIndex_Click(object sender, EventArgs e)
    {
        if (txtCriteria.Text.Trim() != "")
        {
            if (YearArray.IndexOf(txtCriteria.Text.Trim()) > 0)
            {
                lblMessage.Text = "ArrayList Item Found at Index: " + YearArray.IndexOf(txtCriteria.Text.Trim());
            }
            else
            {
                lblMessage.Text = "ArrayList Item Not Found.";
            }
        }
        else
        {
            lblMessage.Text = "Please Enter an Item to Delete";
        }
    }
}
